"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const handleOptions_1 = require("./handleOptions");
function injectExtraAPI(ctx) {
    const { layoutComponentMap } = ctx.themeAPI;
    const isLayoutExists = name => layoutComponentMap[name] !== undefined;
    ctx.getLayout = (name, fallback) => {
        return isLayoutExists(name) ? name : fallback || "Layout";
    };
}
module.exports = (options, ctx) => {
    injectExtraAPI(ctx);
    const { pageEnhancers, extraPages } = handleOptions_1.handleOptions(options, ctx);
    return {
        name: "vuepress-plugin-directory-classifier",
        extendPageData(pageCtx) {
            const { frontmatter: rawFrontMatter } = pageCtx;
            pageEnhancers.forEach(({ when, data = {}, frontmatter = {} }) => {
                if (when(pageCtx)) {
                    Object.keys(frontmatter).forEach(key => {
                        if (!rawFrontMatter[key]) {
                            rawFrontMatter[key] = frontmatter[key];
                        }
                    });
                    Object.assign(pageCtx, data);
                }
            });
        },
        additionalPages: extraPages
    };
};
//# sourceMappingURL=index.js.map